{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UGearRatiosTestCases;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, UGearRatios;

type

  { TGearRatiosTestCase }

  TGearRatiosTestCase = class(TTestCase)
  protected
    FSolver: TGearRatios;
    procedure Setup; override;
    procedure TearDown; override;
  published
    procedure TestPuzzleExample;
    procedure TestEndOfLineNumber;
  end;

implementation

{ TGearRatiosTestCase }

procedure TGearRatiosTestCase.Setup;
begin
  FSolver := TGearRatios.Create;
end;

procedure TGearRatiosTestCase.TearDown;
begin
  FSolver.Free;
end;

procedure TGearRatiosTestCase.TestPuzzleExample;
begin
  FSolver.Init;
  FSolver.ProcessDataLine('467..114..');
  FSolver.ProcessDataLine('...*......');
  FSolver.ProcessDataLine('..35..633.');
  FSolver.ProcessDataLine('......#...');
  FSolver.ProcessDataLine('617*......');
  FSolver.ProcessDataLine('.....+.58.');
  FSolver.ProcessDataLine('..592.....');
  FSolver.ProcessDataLine('......755.');
  FSolver.ProcessDataLine('...$.*....');
  FSolver.ProcessDataLine('.664.598..');
  FSolver.Finish;
  AssertEquals('Result of part 1 calculation incorrect.', 4361, FSolver.GetResultPart1);
end;

procedure TGearRatiosTestCase.TestEndOfLineNumber;
begin
  FSolver.Init;
  FSolver.ProcessDataLine('...$541');
  FSolver.Finish;
  AssertEquals('Result of part 1 calculation incorrect.', 541, FSolver.GetResultPart1);
end;

initialization

  RegisterTest(TGearRatiosTestCase);
end.
